
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class User_ranksDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const user_ranks = await db.user_ranks.create(
            {
                id: data.id || undefined,
        
        rank_points: data.rank_points
        ||
        null
            ,
            
        updated_at_time: data.updated_at_time
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await user_ranks.setUser( data.user || null, {
            transaction,
        });
        
        await user_ranks.setRank_tier( data.rank_tier || null, {
            transaction,
        });
        

        

        

        return user_ranks;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const user_ranksData = data.map((item, index) => ({
                id: item.id || undefined,
                
                rank_points: item.rank_points
            ||
            null
            ,
            
                updated_at_time: item.updated_at_time
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const user_ranks = await db.user_ranks.bulkCreate(user_ranksData, { transaction });

        // For each item created, replace relation files
        

        return user_ranks;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const user_ranks = await db.user_ranks.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.rank_points !== undefined) updatePayload.rank_points = data.rank_points;
        
        
        if (data.updated_at_time !== undefined) updatePayload.updated_at_time = data.updated_at_time;
        
        
        updatePayload.updatedById = currentUser.id;

        await user_ranks.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await user_ranks.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.rank_tier !== undefined) {
            await user_ranks.setRank_tier(
              
              data.rank_tier,
              
              { transaction }
            );
        }
        

        
        

        

        return user_ranks;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const user_ranks = await db.user_ranks.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of user_ranks) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of user_ranks) {
                await record.destroy({transaction});
            }
        });


        return user_ranks;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const user_ranks = await db.user_ranks.findByPk(id, options);

        await user_ranks.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await user_ranks.destroy({
            transaction
        });

        return user_ranks;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const user_ranks = await db.user_ranks.findOne(
            { where },
            { transaction },
        );

        if (!user_ranks) {
            return user_ranks;
        }

        const output = user_ranks.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await user_ranks.getUser({
            transaction
        });
        
        
        output.rank_tier = await user_ranks.getRank_tier({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.rank_tiers,
        as: 'rank_tier',
        
        where: filter.rank_tier ? {
          [Op.or]: [
            { id: { [Op.in]: filter.rank_tier.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.rank_tier.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.rank_pointsRange) {
                const [start, end] = filter.rank_pointsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    rank_points: {
                    ...where.rank_points,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    rank_points: {
                    ...where.rank_points,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.updated_at_timeRange) {
                const [start, end] = filter.updated_at_timeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    updated_at_time: {
                    ...where.updated_at_time,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    updated_at_time: {
                    ...where.updated_at_time,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.user_ranks.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'user_ranks',
                        'rank_points',
                        query,
                    ),
                ],
            };
        }

        const records = await db.user_ranks.findAll({
            attributes: [ 'id', 'rank_points' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['rank_points', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.rank_points,
        }));
    }

    
};

